local spamWindow = 1 -- alter this number if you wish to filter channels to another window
local leaveGeneral = false
local leaveTrade = false
local leaveDefense = true
local leaveServices = true

local addon = ...
local f = CreateFrame("Frame")
local msgcolor = BLUE_FONT_COLOR
local chatframe = SELECTED_CHAT_FRAME
local disable = false

local function printf(msg)
	if not msg then return end
	local output = (addon..": "..msg)
	local colorstring = msgcolor:WrapTextInColorCode(output)
	chatframe:AddMessage(colorstring)
end

local function leavechannels()
	if leaveGeneral then LeaveChannelByName("General") end
	if leaveTrade then LeaveChannelByName("Trade") end
	if leaveDefense then LeaveChannelByName("LocalDefense") end
	if leaveServices then LeaveChannelByName("Services") end
end

local function joinchannels()
	JoinChannelByName("General")
	JoinChannelByName("Trade")
	JoinChannelByName("LocalDefense")
	JoinChannelByName("Services")
end

local function defaults()
	f:SetScript("OnEvent", nil)
	f:UnregisterEvent("CHANNEL_UI_UPDATE")
	joinchannels()
	for i = 1, 10 do
		local cf = _G["ChatFrame"..i]
		if i == 1 then
			ChatFrame_AddChannel(cf, "General")
			ChatFrame_AddChannel(cf, "Trade")
			ChatFrame_AddChannel(cf, "LocalDefense")
			ChatFrame_AddChannel(cf, "Services")
		else
			ChatFrame_RemoveChannel(cf, "General")
			ChatFrame_RemoveChannel(cf, "Trade")
			ChatFrame_RemoveChannel(cf, "LocalDefense")
			ChatFrame_RemoveChannel(cf, "Services")
		end
	end
end

local function fixwindows()
	for i = 1, 10 do
		local cf = _G["ChatFrame"..i]
		if i == spamWindow then
			if not leaveGeneral then ChatFrame_AddChannel(cf, "General") end
			if not leaveTrade then ChatFrame_AddChannel(cf, "Trade") end
			if not leaveDefense then ChatFrame_AddChannel(cf, "LocalDefense") end
			if not leaveServices then ChatFrame_AddChannel(cf, "Services") end
		else
			ChatFrame_RemoveChannel(cf, "General")
			ChatFrame_RemoveChannel(cf, "Trade")
			ChatFrame_RemoveChannel(cf, "LocalDefense")
			ChatFrame_RemoveChannel(cf, "Services")
		end
	end
end

local function OnEvent(self, event, arg1, ...)
	if EnumerateServerChannels() then
		leavechannels()
		fixwindows()
	end
	if event == "PLAYER_ENTERING_WORLD" then
		if arg1 then
			printf("Loaded")
			C_Timer.After(5, joinchannels)
			C_Timer.After(7, fixwindows)
			if disable then  --disable addon via update
				DisableAddOn(addon, UnitName("player"))
			end
		end
	end
end

SlashCmdList["LEAVESPAMCHANNELS"] = function()
	printf("Restoring default channel layout.")
	defaults() -- Restore default channels
end
SLASH_LEAVESPAMCHANNELS1 = '/lsc'

f:SetScript("OnEvent", OnEvent)
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("CHANNEL_UI_UPDATE")
